<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'proxy_check_one');
include_once(dirname(__FILE__).'/../common.php');

//
// INIT
//
if( empty($_GET['host']) ) die('Proxy host is not passed');
if( empty($_GET['port']) ) die('Port port is not passed');
ignore_user_abort(0);
set_time_limit($DBCONF['request_timeout']+60);
$proxy = $_GET['host'].':'.intval($_GET['port']);

//
// CURL
//
if( !function_exists('curl_init') ) die('cURL library is not found');
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $DBCONF['info_url']);
curl_setopt($ch, CURLOPT_TIMEOUT, $DBCONF['request_timeout']);
curl_setopt($ch, CURLOPT_USERAGENT, $CONF['user_agent']);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_REFERER, "proxy_test_referer" );
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, "ptest=proxy_test_post" );
curl_setopt($ch, CURLOPT_COOKIE, "ptest=proxy_test_cookie" );
curl_setopt($ch, CURLOPT_PROXY, $proxy);
$content = curl_exec($ch);

//
// TIME
//
$con_time = curl_getinfo($ch, CURLINFO_CONNECT_TIME);
$tot_time = curl_getinfo($ch, CURLINFO_TOTAL_TIME);

//
// COUNTRY
//
$country = '';
$country_code = '';
$ip = gethostbyname($_GET['host']);
$longip = sprintf("%u", ip2long($ip));
$sql = "SELECT * FROM `".$CONF['tbl_country']."` "
     . "WHERE ip_start<".$longip." "
     . "AND ip_end>".$longip." "
     . "LIMIT 0,1";
$res = $db->sql2array($sql);
if($db->error()) die($db->error());
if( !empty($res) ) {
    $res = @reset($res);
    $country = $res['name'];
    $country_code = $res['zone2'];
}

//
// MARK SECURITY PARAMETERS BY RED COLOR
//
if( preg_match_all("|[^\r\n]+|", $DBCONF['security'], $m) ) {
    foreach($m[0] as $v)
        $content = preg_replace("/".preg_quote($v,'/')."/i", "<span style=\"color:red;\">$0</span>", $content);
}

//
// DISPLAY RESULTS
//
echo "<pre><h2>".$proxy."</h2>";
echo "<b>connect time:</b> ".$con_time."<br>";
echo "<b>total time:</b> ".$tot_time."<br>";
echo "<b>country: </b> ".$country."<br>";
echo "<b>country code: </b> ".$country_code."<br>";
$err = curl_error($ch);
if( !stristr($content, "REQUEST_INFO_PAGE_4896485_CODE") ) echo "<span style=\"color:red;\"><b>Unworked</b></span> ".($err ? "(".$err.")" : "");
echo "</pre><hr>".$content;

curl_close($ch);
?>