<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'export_settings');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/class.pager.php');

if( !empty($_POST) ) {
    if( $_POST['action']=='delete' ) {
        if( $CONF['demo'] ) $fw->conf_err('err_demo');
        else {
            foreach($_POST['id'] as $id) {
                $sql = "DELETE FROM `".$CONF['tbl_export']."` WHERE id=".intval($id);
                if( !$db->query($sql) ) {
                    $fw->conf_err('err_sql','',': '.$db->error() );
                    break;
                }
            }
            if( !$fw->err() ) $fw->conf_inf('inf_ok');
        }
    }

    if( $_POST['action']=='add' ) {
        if( $CONF['demo'] ) $fw->conf_err('err_demo');
        else {
            switch($_POST['type']) {
            case 'file':
                $sql_add = "t_path='".addslashes($_POST['file_path'])."'";
                break;
            case 'mail':
                $sql_add = "t_mail='".addslashes($_POST['mail'])."'";
                break;
            case 'ftp':
                $sql_add = "t_serv='".addslashes($_POST['ftp_serv'])."', "
                         . "t_user='".addslashes($_POST['ftp_user'])."', "
                         . "t_pass='".addslashes($_POST['ftp_pass'])."', "
                         . "t_path='".addslashes($_POST['ftp_path'])."'";
                break;
            }
            $sql = "INSERT INTO `".$CONF['tbl_export']."` SET "
                 . "t_type='".addslashes($_POST['type'])."', "
                 . "f_limit='".intval($_POST['limit'])."', "
                 . "f_port='".addslashes($_POST['port'])."', "
                 . "f_country='".addslashes($_POST['country'])."', "
                 . "f_work='".intval(_safe_var($_POST['work'],0))."', "
                 . "f_post='".intval(_safe_var($_POST['post'],0))."', "
                 . "f_ref='".intval(_safe_var($_POST['ref'],0))."', "
                 . "f_cookies='".intval(_safe_var($_POST['cookies'],0))."', "
                 . "f_anon='".intval($_POST['anon'])."', "
                 . "f_contime='".doubleval($_POST['contime'])."', "
                 . "f_time='".doubleval($_POST['time'])."', "
                 . "f_fresh='".intval($_POST['fresh'])."', "
                 . $sql_add;
            $db->query($sql) ?
                $fw->conf_inf('inf_ok')
            :   $fw->conf_err('err_sql','',': '.$db->error() );
        }
    }
}

//
// LOAD EXPORT TABLE
//
$db->sql2var("SELECT COUNT(*) as count FROM `".$CONF['tbl_export']."`");
$pager = new Pager(_safe_var($count), intval($DBCONF['per_page']), _safe_var($_GET['p'],1) );
$sql = "SELECT * FROM `".$CONF['tbl_export']."` ORDER BY 'type' ".$pager->sql_limit();
$export = $db->sql2array($sql);
$fw->assign('export', $export);
$fw->assign('pages', $pager->get_pages(1,0) );


$fw->assign('file', PROJECT_FILE);
$fw->display('index.tpl');
?>