<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'log');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/class.pager.php');

$log_dir = $fw->dir.'1/';

// CHANGE DISPLAY FILE
if( !empty($_GET['file']) ) {
    $file = urldecode($_GET['file']);
    if( preg_match("#^[^\\\/]+\.log$#i", $file) )
        $_SESSION['log_file'] = basename($file);
}

// DELETE LOG FILES
if( !empty($_POST['delete']) ) {
    $dir = dir($log_dir);
    while( false!==($entry=$dir->read()) )
        if( preg_match("#^(.+)\.log$#i",$entry,$m) and is_file($dir->path.$entry) ) unlink($dir->path.$entry);
    $dir->close();
    $fw->conf_inf('delete_logs_inf');
}

// READ LOG FILES
$files = array();
$dir = dir($log_dir);
while( false!==($entry=$dir->read()) )
    if( preg_match("#^(.+)\.log$#i", $entry, $m) ) $files[] = $entry;
$dir->close();
sort($files);
$fw->assign('files', $files);

// DISPLAY CURRENT FILE
if( is_file($log_dir._safe_var($_SESSION['log_file'])) ) {
    $lines = file($log_dir.$_SESSION['log_file']);
    $lines = array_reverse($lines);
    $pager = new Pager($lines, $DBCONF['per_page'], _safe_var($_GET['p'],1) );
    $fw->assign('lines', $pager->get_part());
    $fw->assign('pages', $pager->get_pages(1, 0, 10, 0) );
}


$fw->assign('file', PROJECT_FILE);
$fw->display('index.tpl');
?>