<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'tool_check_load');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.parser.php');
include_once(dirname(__FILE__).'/../lib/func.detach_proxies.php');

//
// INIT
//
if( empty($_GET['url']) ) die('URL is not passed');
$url = urldecode($_GET['url']);
ignore_user_abort(0);
set_time_limit(0);

//
// CURL
//
if( !function_exists('curl_init') ) die('cURL library is not found');
$ch = curl_init();
curl_setopt($ch, CURLOPT_TIMEOUT, $CONF['request_timeout']);
curl_setopt($ch, CURLOPT_USERAGENT, $CONF['user_agent']);
curl_setopt($ch, CURLOPT_HEADER, 1);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

//
// REQUEST
//
curl_setopt($ch, CURLOPT_URL, $url);
$content = curl_exec($ch);
if( $content===false ) die("Error ".curl_errno($ch).": ".curl_error($ch) );

//
// TIME
//
$con_time = curl_getinfo($ch, CURLINFO_CONNECT_TIME);
$tot_time = curl_getinfo($ch, CURLINFO_TOTAL_TIME);

//
// DETACH PROXIES
//
$decoded = htmlspecialchars_ascii_decode($content);
$decoded = html_entity_decode($decoded);
$addr = detach_proxies($content);

//
// DISPLAY RESULTS
//
echo "<pre><h3><a href=\"".$url."\">".$url."</a></h3>";
echo "<b>connect time:</b> ".$con_time."<br>";
echo "<b>total time:</b> ".$tot_time."<br>";
echo "<b>found:</b> ".count($addr)." addresses<br>";
echo "</pre><hr>".$content;

curl_close($ch);
?>