<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'country');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.parser.php');

set_time_limit(1000);
ignore_user_abort(0);

//
// DETERMINE COUNTRIES
//
if( !empty($_POST) ) {
    $addr = detach_addresses($_POST['addr']);
    $countries = array();
    foreach(_safe_array($addr) as $v) {
        $v = preg_replace("|:\d+$|", "", $v);
        $ip = gethostbyname($v);
        $longip = sprintf("%u", ip2long($ip));
        $sql = "SELECT * FROM `".$CONF['tbl_country']."` "
             . "WHERE ip_start<".$longip." "
             . "AND ip_end>".$longip." "
             . "LIMIT 0,1";
        $res = $db->sql2array($sql);
        if($db->error()) die($db->error());
        if( !empty($res) ) {
            $res = @reset($res);
            $countries[] = array('ip'=>$v, 'country'=>$res['name'], 'code'=>$res['zone2'] );
        }
    }
    $fw->assign('countries', $countries);
}


$fw->assign('file', PROJECT_FILE);
$fw->display('index.tpl');
?>